use std::process::ExitCode;

mod cli;

// Yoinked from keyfork-bin
// TODO: make public in keyfork-bin, make a new release
fn report_err<E: std::error::Error>(e: E) {
    eprintln!("Unable to run command: {e}");
    let mut source = e.source();
    while let Some(new_error) = source.take() {
        eprintln!("- Caused by: {new_error}");
        source = new_error.source();
    }
}

fn main() -> ExitCode {
    cli::do_cli_thing();
    if let Err(e) = Ok::<_, Box<dyn std::error::Error>>(()) {
        report_err(&*e);
        return ExitCode::FAILURE;
        
    }
    ExitCode::SUCCESS
}
