# Solana End to End Tests

This test demonstrates that Keyfork can be loaded, a key can be derived, and a
transaction can be performed using an SPL Token.

We assume for these purposes that an account already exists with enough of the
token to be usable. The flow should be as follows:

1. In one terminal, `run-offline.sh` should be started, with the mnemonic
   entered, to emulate the procurement and operation of the Offline Machine and
   the recovery of the shard.
2. In another terminal, `run-online.sh` should be started, with the
   "sender address" being the address from the mnemonic, the "recipient
   address" being the address of any other previously created account, the
   token name being IPDBG or some other devnet token, and the token amount
   being the amount to transfer - ideally a low amount.
3. Upon entering all the fields, the inputs should be transferred to the
   offline "machine" for validation. Once validated, the offline machine will
   derive the key, sign the transaction, and send it to the online machine for
   transmission.
4. The online machine will return a signature that can be used to validate the
   transaction on the Solana Devnet Blockchain Explorer.
